diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/wifi-phy-reception-test.cc ns-3.38/src/wifi/test/wifi-phy-reception-test.cc
--- ns-3.37/src/wifi/test/wifi-phy-reception-test.cc	2022-11-01 17:37:24.763395800 -0700
+++ ns-3.38/src/wifi/test/wifi-phy-reception-test.cc	2023-03-16 20:54:23.876869400 -0700
@@ -49,6 +49,8 @@
 #include "ns3/wifi-spectrum-value-helper.h"
 #include "ns3/wifi-utils.h"
 
+#include <optional>
+
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE("WifiPhyReceptionTest");
@@ -115,7 +117,7 @@
     /**
      * Check the number of received packets
      * \param expectedSuccessCount the number of successfully received packets
-     * \param expectedFailureCount the number of unsuccessfully received packets
+     * \param expectedFailureCount the number of unsuccessfuly received packets
      */
     void CheckRxPacketCount(uint32_t expectedSuccessCount, uint32_t expectedFailureCount);
 
@@ -160,6 +162,7 @@
     txParams->txPhy = nullptr;
     txParams->duration = txDuration;
     txParams->ppdu = ppdu;
+    txParams->txWidth = CHANNEL_WIDTH;
 
     m_phy->StartRx(txParams);
 }
@@ -168,7 +171,7 @@
 TestThresholdPreambleDetectionWithoutFrameCapture::CheckPhyState(WifiPhyState expectedState)
 {
     // This is needed to make sure PHY state will be checked as the last event if a state change
-    // occured at the exact same time as the check
+    // occurred at the exact same time as the check
     Simulator::ScheduleNow(&TestThresholdPreambleDetectionWithoutFrameCapture::DoCheckPhyState,
                            this,
                            expectedState);
@@ -788,7 +791,7 @@
     /**
      * Check the number of received packets
      * \param expectedSuccessCount the number of successfully received packets
-     * \param expectedFailureCount the number of unsuccessfully received packets
+     * \param expectedFailureCount the number of unsuccessfuly received packets
      */
     void CheckRxPacketCount(uint32_t expectedSuccessCount, uint32_t expectedFailureCount);
 
@@ -841,7 +844,7 @@
 TestThresholdPreambleDetectionWithFrameCapture::CheckPhyState(WifiPhyState expectedState)
 {
     // This is needed to make sure PHY state will be checked as the last event if a state change
-    // occured at the exact same time as the check
+    // occurred at the exact same time as the check
     Simulator::ScheduleNow(&TestThresholdPreambleDetectionWithFrameCapture::DoCheckPhyState,
                            this,
                            expectedState);
@@ -2154,7 +2157,7 @@
 TestPhyHeadersReception::CheckPhyState(WifiPhyState expectedState)
 {
     // This is needed to make sure PHY state will be checked as the last event if a state change
-    // occured at the exact same time as the check
+    // occurred at the exact same time as the check
     Simulator::ScheduleNow(&TestPhyHeadersReception::DoCheckPhyState, this, expectedState);
 }
 
@@ -2611,8 +2614,8 @@
     uint8_t m_rxSuccessBitmapAmpdu1; ///< bitmap of successfully received MPDUs in A-MPDU #1
     uint8_t m_rxSuccessBitmapAmpdu2; ///< bitmap of successfully received MPDUs in A-MPDU #2
 
-    uint8_t m_rxFailureBitmapAmpdu1; ///< bitmap of unsuccessfully received MPDUs in A-MPDU #1
-    uint8_t m_rxFailureBitmapAmpdu2; ///< bitmap of unsuccessfully received MPDUs in A-MPDU #2
+    uint8_t m_rxFailureBitmapAmpdu1; ///< bitmap of unsuccessfuly received MPDUs in A-MPDU #1
+    uint8_t m_rxFailureBitmapAmpdu2; ///< bitmap of unsuccessfuly received MPDUs in A-MPDU #2
 
     uint8_t m_rxDroppedBitmapAmpdu1; ///< bitmap of dropped MPDUs in A-MPDU #1
     uint8_t m_rxDroppedBitmapAmpdu2; ///< bitmap of dropped MPDUs in A-MPDU #2
@@ -2870,6 +2873,7 @@
     txParams->txPhy = nullptr;
     txParams->duration = txDuration;
     txParams->ppdu = ppdu;
+    txParams->txWidth = CHANNEL_WIDTH;
 
     m_phy->StartRx(txParams);
 }
@@ -4293,6 +4297,458 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
+ * \brief Unsupported Bandwidth Reception Test
+ * This test checks whether a PHY receiving a PPDU sent over a channel width
+ * larger than the one supported by the PHY is getting dropped at the expected
+ * time. The expected time corresponds to the moment the PHY header indicating
+ * the channel width used to transmit the PPDU is received. Since we are considering
+ * 802.11ax for this test, this corresponds to the time HE-SIG-A is received.
+ */
+class TestUnsupportedBandwidthReception : public TestCase
+{
+  public:
+    TestUnsupportedBandwidthReception();
+
+  private:
+    void DoSetup() override;
+    void DoTeardown() override;
+    void DoRun() override;
+
+    /**
+     * Function to create a PPDU
+     *
+     * \param band the PHY band to use
+     * \param centerFreqMhz the center frequency used for the transmission of the PPDU (in MHz)
+     * \param bandwidthMhz the bandwidth used for the transmission of the PPDU (in MHz)
+     */
+    void SendPpdu(WifiPhyBand band, uint16_t centerFreqMhz, uint16_t bandwidthMhz);
+
+    /**
+     * Function called upon a PSDU received successfully
+     * \param psdu the PSDU
+     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * \param txVector the transmit vector
+     * \param statusPerMpdu reception status per MPDU
+     */
+    void RxSuccess(Ptr<const WifiPsdu> psdu,
+                   RxSignalInfo rxSignalInfo,
+                   WifiTxVector txVector,
+                   std::vector<bool> statusPerMpdu);
+
+    /**
+     * Function called upon a PSDU received unsuccessfuly
+     * \param psdu the PSDU
+     */
+    void RxFailure(Ptr<const WifiPsdu> psdu);
+
+    /**
+     * Function called upon a PSDU dropped by the PHY
+     * \param packet the packet that was dropped
+     * \param reason the reason the packet was dropped
+     */
+    void RxDropped(Ptr<const Packet> packet, WifiPhyRxfailureReason reason);
+
+    /**
+     * Check the reception results
+     * \param expectedCountRxSuccess the expected number of RX success
+     * \param expectedCountRxFailure the expected number of RX failure
+     * \param expectedCountRxDropped the expected number of RX drop
+     * \param expectedLastRxSucceeded the expected time the last RX success occurred or std::nullopt
+     * if the expected number of RX success is not strictly positive \param expectedLastRxFailed the
+     * expected time the last RX failure occurred or std::nullopt if the expected number of RX
+     * failure is not strictly positive \param expectedLastRxDropped the expected time the last RX
+     * drop occurred or std::nullopt if the expected number of RX drop is not strictly positive
+     */
+    void CheckRx(uint32_t expectedCountRxSuccess,
+                 uint32_t expectedCountRxFailure,
+                 uint32_t expectedCountRxDropped,
+                 std::optional<Time> expectedLastRxSucceeded,
+                 std::optional<Time> expectedLastRxFailed,
+                 std::optional<Time> expectedLastRxDropped);
+
+    uint32_t m_countRxSuccess; ///< count RX success
+    uint32_t m_countRxFailure; ///< count RX failure
+    uint32_t m_countRxDropped; ///< count RX drop
+
+    std::optional<Time> m_lastRxSucceeded; ///< time of last RX success, if any
+    std::optional<Time> m_lastRxFailed;    ///< time of last RX failure, if any
+    std::optional<Time> m_lastRxDropped;   ///< time of last RX drop, if any
+
+    Ptr<SpectrumWifiPhy> m_phy; ///< PHY
+};
+
+TestUnsupportedBandwidthReception::TestUnsupportedBandwidthReception()
+    : TestCase("Check correct behavior when a STA is receiving a transmission using an unsupported "
+               "bandwidth"),
+      m_countRxSuccess(0),
+      m_countRxFailure(0),
+      m_countRxDropped(0),
+      m_lastRxSucceeded(std::nullopt),
+      m_lastRxFailed(std::nullopt),
+      m_lastRxDropped(std::nullopt)
+{
+}
+
+void
+TestUnsupportedBandwidthReception::SendPpdu(WifiPhyBand band,
+                                            uint16_t centerFreqMhz,
+                                            uint16_t bandwidthMhz)
+{
+    auto txVector =
+        WifiTxVector(HePhy::GetHeMcs0(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, bandwidthMhz, false);
+
+    auto pkt = Create<Packet>(1000);
+    WifiMacHeader hdr;
+
+    hdr.SetType(WIFI_MAC_QOSDATA);
+    hdr.SetQosTid(0);
+
+    Ptr<WifiPsdu> psdu = Create<WifiPsdu>(pkt, hdr);
+    Time txDuration = m_phy->CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand());
+
+    auto ppdu = Create<HePpdu>(psdu, txVector, centerFreqMhz, txDuration, WIFI_PHY_BAND_5GHZ, 0);
+
+    auto txPowerSpectrum =
+        WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(centerFreqMhz,
+                                                                    bandwidthMhz,
+                                                                    DbmToW(-50),
+                                                                    bandwidthMhz);
+
+    auto txParams = Create<WifiSpectrumSignalParameters>();
+    txParams->psd = txPowerSpectrum;
+    txParams->txPhy = nullptr;
+    txParams->duration = txDuration;
+    txParams->ppdu = ppdu;
+    txParams->txWidth = bandwidthMhz;
+
+    m_phy->StartRx(txParams);
+}
+
+void
+TestUnsupportedBandwidthReception::RxSuccess(Ptr<const WifiPsdu> psdu,
+                                             RxSignalInfo rxSignalInfo,
+                                             WifiTxVector txVector,
+                                             std::vector<bool> statusPerMpdu)
+{
+    NS_LOG_FUNCTION(this << *psdu << rxSignalInfo << txVector);
+    m_countRxSuccess++;
+    m_lastRxSucceeded = Simulator::Now();
+}
+
+void
+TestUnsupportedBandwidthReception::RxFailure(Ptr<const WifiPsdu> psdu)
+{
+    NS_LOG_FUNCTION(this << *psdu);
+    m_countRxFailure++;
+    m_lastRxFailed = Simulator::Now();
+}
+
+void
+TestUnsupportedBandwidthReception::RxDropped(Ptr<const Packet> p, WifiPhyRxfailureReason reason)
+{
+    NS_LOG_FUNCTION(this << p << reason);
+    NS_ASSERT(reason == UNSUPPORTED_SETTINGS);
+    m_countRxDropped++;
+    m_lastRxDropped = Simulator::Now();
+}
+
+void
+TestUnsupportedBandwidthReception::CheckRx(uint32_t expectedCountRxSuccess,
+                                           uint32_t expectedCountRxFailure,
+                                           uint32_t expectedCountRxDropped,
+                                           std::optional<Time> expectedLastRxSucceeded,
+                                           std::optional<Time> expectedLastRxFailed,
+                                           std::optional<Time> expectedLastRxDropped)
+{
+    NS_TEST_ASSERT_MSG_EQ(m_countRxSuccess,
+                          expectedCountRxSuccess,
+                          "Didn't receive right number of successful packets");
+
+    NS_TEST_ASSERT_MSG_EQ(m_countRxFailure,
+                          expectedCountRxFailure,
+                          "Didn't receive right number of unsuccessful packets");
+
+    NS_TEST_ASSERT_MSG_EQ(m_countRxDropped,
+                          expectedCountRxDropped,
+                          "Didn't receive right number of dropped packets");
+
+    if (expectedCountRxSuccess > 0)
+    {
+        NS_ASSERT(m_lastRxSucceeded.has_value());
+        NS_ASSERT(expectedLastRxSucceeded.has_value());
+        NS_TEST_ASSERT_MSG_EQ(m_lastRxSucceeded.value(),
+                              expectedLastRxSucceeded.value(),
+                              "Didn't receive the last successful packet at the expected time");
+    }
+
+    if (expectedCountRxFailure > 0)
+    {
+        NS_ASSERT(m_lastRxFailed.has_value());
+        NS_ASSERT(expectedLastRxFailed.has_value());
+        NS_TEST_ASSERT_MSG_EQ(m_lastRxFailed.value(),
+                              expectedLastRxFailed.value(),
+                              "Didn't receive the last unsuccessful packet at the expected time");
+    }
+
+    if (expectedCountRxDropped > 0)
+    {
+        NS_ASSERT(m_lastRxDropped.has_value());
+        NS_ASSERT(expectedLastRxDropped.has_value());
+        NS_TEST_ASSERT_MSG_EQ(m_lastRxDropped.value(),
+                              expectedLastRxDropped.value(),
+                              "Didn't drop the last filtered packet at the expected time");
+    }
+}
+
+void
+TestUnsupportedBandwidthReception::DoSetup()
+{
+    m_phy = CreateObject<SpectrumWifiPhy>();
+    m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
+    auto interferenceHelper = CreateObject<InterferenceHelper>();
+    m_phy->SetInterferenceHelper(interferenceHelper);
+    auto error = CreateObject<NistErrorRateModel>();
+    m_phy->SetErrorRateModel(error);
+
+    m_phy->SetReceiveOkCallback(MakeCallback(&TestUnsupportedBandwidthReception::RxSuccess, this));
+    m_phy->SetReceiveErrorCallback(
+        MakeCallback(&TestUnsupportedBandwidthReception::RxFailure, this));
+    m_phy->TraceConnectWithoutContext(
+        "PhyRxDrop",
+        MakeCallback(&TestUnsupportedBandwidthReception::RxDropped, this));
+}
+
+void
+TestUnsupportedBandwidthReception::DoTeardown()
+{
+    m_phy->Dispose();
+    m_phy = nullptr;
+}
+
+void
+TestUnsupportedBandwidthReception::DoRun()
+{
+    RngSeedManager::SetSeed(1);
+    RngSeedManager::SetRun(1);
+
+    int64_t streamNumber = 0;
+    m_phy->AssignStreams(streamNumber);
+
+    // Case 1: the PHY is operating on channel 36 (20 MHz) and receives a 40 MHz PPDU (channel 38).
+    // The PPDU should be dropped once HE-SIG-A is successfully received, since it contains
+    // indication about the BW used for the transmission and the PHY shall detect it is larger than
+    // its operating BW.
+    m_phy->SetOperatingChannel(WifiPhy::ChannelTuple{36, 20, WIFI_PHY_BAND_5GHZ, 0});
+
+    Simulator::Schedule(Seconds(1.0),
+                        &TestUnsupportedBandwidthReception::SendPpdu,
+                        this,
+                        WIFI_PHY_BAND_5GHZ,
+                        5190,
+                        40);
+
+    auto heSigAExpectedRxTime = Seconds(1.0) + MicroSeconds(32);
+    Simulator::Schedule(Seconds(1.5),
+                        &TestUnsupportedBandwidthReception::CheckRx,
+                        this,
+                        0,
+                        0,
+                        1,
+                        std::nullopt,
+                        std::nullopt,
+                        heSigAExpectedRxTime);
+
+    // TODO: this test can be extended with other scenarios
+
+    Simulator::Run();
+    Simulator::Destroy();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Primary 20 MHz Covered By Ppdu Test
+ * This test checks whether the functions WifiPpdu::DoesOverlapChannel and
+ * WifiPpdu::DoesCoverChannel are returning the expected results.
+ */
+class TestPrimary20CoveredByPpdu : public TestCase
+{
+  public:
+    TestPrimary20CoveredByPpdu();
+
+  private:
+    void DoSetup() override;
+    void DoRun() override;
+    void DoTeardown() override;
+
+    /**
+     * Function to create a PPDU
+     *
+     * \param band the PHY band to use
+     * \param ppduCenterFreqMhz the center frequency used for the transmission of the PPDU (in MHz)
+     * \return the created PPDU
+     */
+    Ptr<HePpdu> CreatePpdu(WifiPhyBand band, uint16_t ppduCenterFreqMhz);
+
+    /**
+     * Run one function
+     *
+     * \param band the PHY band to use
+     * \param phyCenterFreqMhz the operating center frequency of the PHY (in MHz)
+     * \param p20Index the primary20 index
+     * \param ppduCenterFreqMhz the center frequency used for the transmission of the PPDU (in MHz)
+     * \param expectedP20Overlap flag whether the primary 20 MHz channel is expected to be fully
+     * covered by the bandwidth of the incoming PPDU
+     * \param expectedP20Covered flag whether the
+     * primary 20 MHz channel is expected to overlap with the bandwidth of the incoming PPDU
+     */
+    void RunOne(WifiPhyBand band,
+                uint16_t phyCenterFreqMhz,
+                uint8_t p20Index,
+                uint16_t ppduCenterFreqMhz,
+                bool expectedP20Overlap,
+                bool expectedP20Covered);
+
+    Ptr<SpectrumWifiPhy> m_phy; ///< PHY
+};
+
+TestPrimary20CoveredByPpdu::TestPrimary20CoveredByPpdu()
+    : TestCase("Check correct detection of whether P20 is fully covered (hence it can be received) "
+               "or overlaps with the bandwidth of an incoming PPDU")
+{
+}
+
+Ptr<HePpdu>
+TestPrimary20CoveredByPpdu::CreatePpdu(WifiPhyBand band, uint16_t ppduCenterFreqMhz)
+{
+    [[maybe_unused]] auto [channelNumber, centerFreq, channelWidth, type, phyBand] =
+        (*WifiPhyOperatingChannel::FindFirst(0, ppduCenterFreqMhz, 0, WIFI_STANDARD_80211ax, band));
+
+    auto txVector =
+        WifiTxVector(HePhy::GetHeMcs7(), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, channelWidth, false);
+
+    auto pkt = Create<Packet>(1000);
+    WifiMacHeader hdr(WIFI_MAC_QOSDATA);
+
+    auto psdu = Create<WifiPsdu>(pkt, hdr);
+    auto txDuration = m_phy->CalculateTxDuration(psdu->GetSize(), txVector, band);
+
+    return Create<HePpdu>(psdu, txVector, ppduCenterFreqMhz, txDuration, band, 0);
+}
+
+void
+TestPrimary20CoveredByPpdu::DoSetup()
+{
+    m_phy = CreateObject<SpectrumWifiPhy>();
+    m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
+    auto interferenceHelper = CreateObject<InterferenceHelper>();
+    m_phy->SetInterferenceHelper(interferenceHelper);
+    auto error = CreateObject<NistErrorRateModel>();
+    m_phy->SetErrorRateModel(error);
+}
+
+void
+TestPrimary20CoveredByPpdu::DoTeardown()
+{
+    m_phy->Dispose();
+    m_phy = nullptr;
+}
+
+void
+TestPrimary20CoveredByPpdu::RunOne(WifiPhyBand band,
+                                   uint16_t phyCenterFreqMhz,
+                                   uint8_t p20Index,
+                                   uint16_t ppduCenterFreqMhz,
+                                   bool expectedP20Overlap,
+                                   bool expectedP20Covered)
+{
+    [[maybe_unused]] const auto [channelNumber, centerFreq, channelWidth, type, phyBand] =
+        (*WifiPhyOperatingChannel::FindFirst(0, phyCenterFreqMhz, 0, WIFI_STANDARD_80211ax, band));
+
+    m_phy->SetOperatingChannel(WifiPhy::ChannelTuple{channelNumber, channelWidth, band, p20Index});
+    auto p20CenterFreq = m_phy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(20);
+    auto p20MinFreq = p20CenterFreq - 10;
+    auto p20MaxFreq = p20CenterFreq + 10;
+
+    auto ppdu = CreatePpdu(band, ppduCenterFreqMhz);
+
+    auto p20Overlap = ppdu->DoesOverlapChannel(p20MinFreq, p20MaxFreq);
+    NS_TEST_ASSERT_MSG_EQ(p20Overlap,
+                          expectedP20Overlap,
+                          "PPDU is " << (expectedP20Overlap ? "expected" : "not expected")
+                                     << " to overlap with the P20");
+
+    auto p20Covered =
+        m_phy->GetPhyEntity(WIFI_STANDARD_80211ax)
+            ->CanStartRx(
+                ppdu,
+                ppdu->GetTxVector()
+                    .GetChannelWidth()); // CanStartRx returns true is the P20 is fully covered
+    NS_TEST_ASSERT_MSG_EQ(p20Covered,
+                          expectedP20Covered,
+                          "PPDU is " << (expectedP20Covered ? "expected" : "not expected")
+                                     << " to cover the whole P20");
+}
+
+void
+TestPrimary20CoveredByPpdu::DoRun()
+{
+    /*
+     * Receiver PHY Operating Channel: 2.4 GHz Channel 4 (2417 MHz – 2437 MHz)
+     * Transmitted 20 MHz PPDU: 2.4 GHz Channel 4 (2417 MHz – 2437 MHz)
+     * Overlap with primary 20 MHz: yes
+     * Primary 20 MHz fully covered: yes
+     */
+    RunOne(WIFI_PHY_BAND_2_4GHZ, 2427, 0, 2427, true, true);
+
+    /*
+     * Receiver PHY Operating Channel: 2.4 GHz Channel 4 (2417 MHz – 2437 MHz)
+     * Transmitted 40 MHz PPDU: 2.4 GHz Channel 6 (2427 MHz – 2447 MHz)
+     * Overlap with primary 20 MHz: yes
+     * Primary 20 MHz fully covered: no
+     */
+    RunOne(WIFI_PHY_BAND_2_4GHZ, 2427, 0, 2437, true, false);
+
+    /*
+     * Receiver PHY Operating Channel: 5 GHz Channel 36 (5170 MHz – 5190 MHz)
+     * Transmitted 40 MHz PPDU: 5 GHz Channel 38 (5170 MHz – 5210 MHz)
+     * Overlap with primary 20 MHz: yes
+     * Primary 20 MHz fully covered: yes
+     */
+    RunOne(WIFI_PHY_BAND_5GHZ, 5180, 0, 5190, true, true);
+
+    /*
+     * Receiver PHY Operating Channel: 5 GHz Channel 36 (5170 MHz–5190 MHz)
+     * Transmitted 20 MHz PPDU: 5 GHz Channel 40 (5190 MHz – 5210 MHz)
+     * Overlap with primary 20 MHz: no
+     * Primary 20 MHz fully covered: no
+     */
+    RunOne(WIFI_PHY_BAND_5GHZ, 5180, 0, 5200, false, false);
+
+    /*
+     * Receiver PHY Operating Channel: 5 GHz Channel 38 (5170 MHz – 5210 MHz) with P20 index 0
+     * Transmitted 20 MHz PPDU: 5 GHz Channel 36 (5170 MHz – 5190 MHz)
+     * Overlap with primary 20 MHz: yes
+     * Primary 20 MHz fully covered: yes
+     */
+    RunOne(WIFI_PHY_BAND_5GHZ, 5190, 0, 5180, true, true);
+
+    /*
+     * Receiver PHY Operating Channel: 5 GHz Channel 38 (5170 MHz – 5210 MHz) with P20 index 1
+     * Transmitted 20 MHz PPDU: 5 GHz Channel 36 (5170 MHz – 5190 MHz)
+     * Overlap with primary 20 MHz: no
+     * Primary 20 MHz fully covered: no
+     */
+    RunOne(WIFI_PHY_BAND_5GHZ, 5190, 1, 5180, false, false);
+
+    Simulator::Destroy();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
  * \brief wifi PHY reception Test Suite
  */
 class WifiPhyReceptionTestSuite : public TestSuite
@@ -4310,6 +4766,8 @@
     AddTestCase(new TestPhyHeadersReception, TestCase::QUICK);
     AddTestCase(new TestAmpduReception, TestCase::QUICK);
     AddTestCase(new TestUnsupportedModulationReception(), TestCase::QUICK);
+    AddTestCase(new TestUnsupportedBandwidthReception(), TestCase::QUICK);
+    AddTestCase(new TestPrimary20CoveredByPpdu(), TestCase::QUICK);
 }
 
 static WifiPhyReceptionTestSuite wifiPhyReceptionTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/wifi-phy-thresholds-test.cc ns-3.38/src/wifi/test/wifi-phy-thresholds-test.cc
--- ns-3.37/src/wifi/test/wifi-phy-thresholds-test.cc	2022-11-01 17:37:24.763395800 -0700
+++ ns-3.38/src/wifi/test/wifi-phy-thresholds-test.cc	2023-03-16 20:54:23.876869400 -0700
@@ -110,7 +110,7 @@
 
     Ptr<SpectrumWifiPhy> m_phy;   ///< PHY object
     uint32_t m_rxSuccess;         ///< count number of successfully received packets
-    uint32_t m_rxFailure;         ///< count number of unsuccessfully received packets
+    uint32_t m_rxFailure;         ///< count number of unsuccessfuly received packets
     uint32_t m_rxDropped;         ///< count number of dropped packets
     uint32_t m_stateChanged;      ///< count number of PHY state change
     uint32_t m_rxStateCount;      ///< count number of PHY state change to RX state
@@ -165,6 +165,7 @@
     txParams->txPhy = nullptr;
     txParams->duration = txDuration;
     txParams->ppdu = ppdu;
+    txParams->txWidth = CHANNEL_WIDTH;
     return txParams;
 }
 
@@ -406,7 +407,7 @@
 
     NS_TEST_ASSERT_MSG_EQ(m_rxDropped + m_rxFailure,
                           0,
-                          "Packet reception should have been successfull");
+                          "Packet reception should have been successful");
     NS_TEST_ASSERT_MSG_EQ(m_rxSuccess, 1, "Packet should have been successfully received");
     NS_TEST_ASSERT_MSG_EQ(m_ccabusyStateCount, 2, "State should have moved to CCA_BUSY once");
     NS_TEST_ASSERT_MSG_EQ(
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/wifi-primary-channels-test.cc ns-3.38/src/wifi/test/wifi-primary-channels-test.cc
--- ns-3.37/src/wifi/test/wifi-primary-channels-test.cc	2022-11-01 17:37:24.763395800 -0700
+++ ns-3.38/src/wifi/test/wifi-primary-channels-test.cc	2023-03-16 20:54:23.876869400 -0700
@@ -834,7 +834,7 @@
 
         auto staDev = DynamicCast<WifiNetDevice>(m_staDevices[bss].Get(i - 1));
         uint16_t staId = DynamicCast<StaWifiMac>(staDev->GetMac())->GetAssociationId();
-        txVector.SetHeMuUserInfo(staId, {{ruType, index, primary80}, HePhy::GetHeMcs8(), 1});
+        txVector.SetHeMuUserInfo(staId, {{ruType, index, primary80}, 8, 1});
         hdr.SetAddr1(staDev->GetMac()->GetAddress());
         psduMap[staId] = Create<const WifiPsdu>(Create<Packet>(1000), hdr);
     }
@@ -929,8 +929,8 @@
                               false,
                               false,
                               bssColor);
-        txVector.SetHeMuUserInfo(staId, {{ruType, index, primary80}, HePhy::GetHeMcs8(), 1});
-        trigVector.SetHeMuUserInfo(staId, {{ruType, index, primary80}, HePhy::GetHeMcs8(), 1});
+        txVector.SetHeMuUserInfo(staId, {{ruType, index, primary80}, 8, 1});
+        trigVector.SetHeMuUserInfo(staId, {{ruType, index, primary80}, 8, 1});
 
         hdr.SetAddr2(staDev->GetMac()->GetAddress());
         Ptr<const WifiPsdu> psdu = Create<const WifiPsdu>(Create<Packet>(1000), hdr);
@@ -954,7 +954,7 @@
 
     // AP's PHY expects to receive a TRIGVECTOR (just once)
     trigVector.SetLength(length);
-    auto apHePhy = StaticCast<HePhy>(apDev->GetPhy()->GetPhyEntity(WIFI_MOD_CLASS_HE));
+    auto apHePhy = StaticCast<HePhy>(apDev->GetPhy()->GetLatestPhyEntity());
     apHePhy->SetTrigVector(trigVector, duration);
 }
 
@@ -965,7 +965,7 @@
     {
         auto dev = DynamicCast<WifiNetDevice>(m_apDevices.Get(bss));
         auto mac = DynamicCast<ApWifiMac>(dev->GetMac());
-        NS_TEST_EXPECT_MSG_EQ(mac->GetStaList().size(),
+        NS_TEST_EXPECT_MSG_EQ(mac->GetStaList(SINGLE_LINK_OP_ID).size(),
                               m_nStationsPerBss,
                               "Not all the stations completed association");
     }
